//---------------------------------------------------------------------------
#ifndef ClockLabel_COMH
#define ClockLabel_COMH
//---------------------------------------------------------------------------
#include "ClockLabel_TLB.h"
#include "ClockLabel_prop.h"
#include <StdCtrls.hpp>

// The following define is utilized by the IDEs Code Manager to ensure that
// your controls Library Identifier is kept up-to-date.
// NOTE: Do not remove or modify this macro.
//
#define LIBID_ClockLabelX LIBID_ClockLabel

class ATL_NO_VTABLE TClockLabelXImpl:
  VCLCONTROL_IMPL(TClockLabelXImpl, ClockLabelX, TStaticText, IClockLabelX, DIID_IClockLabelXEvents)
{
  void __fastcall ClickEvent(TObject *Sender);
  void __fastcall DblClickEvent(TObject *Sender);
public:

  void InitializeControl()
  {
    m_VclCtl->OnClick = ClickEvent;
    m_VclCtl->OnDblClick = DblClickEvent;
  }


// The COM MAP entries declares the interfaces your object exposes (through
// QueryInterface). CComRootObjectEx::InternalQueryInterface only returns
// pointers for interfaces in the COM map. VCL controls exposed as OCXes
// have a minimum set of interfaces defined by the
// VCL_CONTROL_COM_INTERFACE_ENTRIES macro. Add other interfaces supported
// by your object with additional COM_INTERFACE_ENTRY[_xxx] macros.
//
BEGIN_COM_MAP(TClockLabelXImpl)
  VCL_CONTROL_COM_INTERFACE_ENTRIES(IClockLabelX)
END_COM_MAP()



// The PROPERTY map stores property descriptions, property DISPIDs,
// property page CLSIDs and IDispatch IIDs. You may use use
// IPerPropertyBrowsingImpl, IPersistPropertyBagImpl, IPersistStreamInitImpl,
// and ISpecifyPropertyPageImpl to utilize the information in you property
// map.
//
// NOTE: The BCB Wizard does *NOT* maintain your PROPERTY_MAP table. You must
//       add or remove entries manually.
//
BEGIN_PROPERTY_MAP(TClockLabelXImpl)
    PROP_PAGE(CLSID_ClockLabelProperties)
END_PROPERTY_MAP()

// The DECLARE_ACTIVEXCONTROL_REGISTRY macro declares a static 'UpdateRegistry' 
// routine which registers the basic information about your control. The
// parameters expected by the macro are the ProgId & the ToolboxBitmap ID of
// your control.
//
DECLARE_ACTIVEXCONTROL_REGISTRY("ClockLabel.ClockLabelX", 1);

protected: 
  STDMETHOD(_set_Font(IFontDisp* Value));
  STDMETHOD(AboutBox());
  STDMETHOD(ClassNameIs(BSTR string, VARIANT_BOOL* Value));
  STDMETHOD(get_Alignment(TxAlignment* Value));
  STDMETHOD(get_AutoSize(VARIANT_BOOL* Value));
  STDMETHOD(get_BorderStyle(TxStaticBorderStyle* Value));
  STDMETHOD(get_Caption(BSTR* Value));
  STDMETHOD(get_Color(OLE_COLOR* Value));
  STDMETHOD(get_Cursor(short* Value));
  STDMETHOD(get_DragCursor(short* Value));
  STDMETHOD(get_DragMode(TxDragMode* Value));
  STDMETHOD(get_Enabled(VARIANT_BOOL* Value));
  STDMETHOD(get_Font(IFontDisp** Value));
  STDMETHOD(get_ParentColor(VARIANT_BOOL* Value));
  STDMETHOD(get_ParentFont(VARIANT_BOOL* Value));
  STDMETHOD(get_ShowAccelChar(VARIANT_BOOL* Value));
  STDMETHOD(get_Visible(VARIANT_BOOL* Value));
  STDMETHOD(set_Alignment(TxAlignment Value));
  STDMETHOD(set_AutoSize(VARIANT_BOOL Value));
  STDMETHOD(set_BorderStyle(TxStaticBorderStyle Value));
  STDMETHOD(set_Caption(BSTR Value));
  STDMETHOD(set_Color(OLE_COLOR Value));
  STDMETHOD(set_Cursor(short Value));
  STDMETHOD(set_DragCursor(short Value));
  STDMETHOD(set_DragMode(TxDragMode Value));
  STDMETHOD(set_Enabled(VARIANT_BOOL Value));
  STDMETHOD(set_Font(IFontDisp* Value));
  STDMETHOD(set_ParentColor(VARIANT_BOOL Value));
  STDMETHOD(set_ParentFont(VARIANT_BOOL Value));
  STDMETHOD(set_ShowAccelChar(VARIANT_BOOL Value));
  STDMETHOD(set_Visible(VARIANT_BOOL Value)); 
  STDMETHOD(get_Active(VARIANT_BOOL* Value));
  STDMETHOD(get_ShowDate(VARIANT_BOOL* Value));
  STDMETHOD(get_UpdateInterval(long* Value));
  STDMETHOD(set_Active(VARIANT_BOOL Value));
  STDMETHOD(set_ShowDate(VARIANT_BOOL Value));
  STDMETHOD(set_UpdateInterval(long Value));
private:
  TTimer*  FTimer;
  bool     FShowDate;
  void __fastcall OnTimer(TObject* Sender);

public:
  __fastcall TClockLabelXImpl();
  __fastcall ~TClockLabelXImpl();

  HRESULT IPersistStreamInit_Load(LPSTREAM pStm, ATL_PROPMAP_ENTRY* pMap);
  HRESULT IPersistStreamInit_Save(LPSTREAM pStm, BOOL fClearDirty,
    ATL_PROPMAP_ENTRY* pMap);
};
//---------------------------------------------------------------------------
#endif
