//---------------------------------------------------------------------------
#ifndef ClockLabelImplH
#define ClockLabelImplH
//---------------------------------------------------------------------------
#include "ClockLabel_TLB.h"
#include <StdCtrls.hpp>

class ATL_NO_VTABLE TClockLabelXImpl:
  VCLCONTROL_IMPL(TClockLabelXImpl, ClockLabelX, TStaticText, IClockLabelX, DIID_IClockLabelXEvents)
{
  void __fastcall ClickEvent(TObject *Sender);
  void __fastcall DblClickEvent(TObject *Sender);
public:

  void InitializeControl()
  {
    m_VclCtl->OnClick = ClickEvent;
    m_VclCtl->OnDblClick = DblClickEvent;
  }

// The COM MAP entries declares the interfaces your object exposes (through
// QueryInterface). CComRootObjectEx::InternalQueryInterface only returns
// pointers for interfaces in the COM map. VCL controls exposed as OCXes
// have a minimum set of interfaces defined by the
// VCL_CONTROL_COM_INTERFACE_ENTRIES macro. Add other interfaces supported
// by your object with additional COM_INTERFACE_ENTRY[_xxx] macros.
//
BEGIN_COM_MAP(TClockLabelXImpl)
  VCL_CONTROL_COM_INTERFACE_ENTRIES(IClockLabelX)
END_COM_MAP()

  // Licensing support
  //
  typedef TLicenseString<TClockLabelXImpl> TLicenseClassImpl;
  DECLARE_CLASSFACTORY2(TLicenseClassImpl)

  // Add logic to determine whether this Control is properly licensed on this machine
  // in the following method..
  //
  static const WCHAR* GetLicenseString()
  {
    return L"{854CE9DB-DCC2-11D3-A084-0080C8FDD37F}";
  }

  static const TCHAR* GetLicenseFileName()
  {
    return _T("ClockLabel.lic");
  }

  static BOOL IsLicenseValid()
  {
    // By default we validate the license by verifying that the
    // license string GUID is in the .LIC file generated by the Wizard.
    //
    // You may replace the logic of this routine to implement another
    // method to verify that your control is properly licensed.
    //
    return TValidateLicense::IsGUIDInFile(GetLicenseString(), GetLicenseFileName());
  }



// The PROPERTY map stores property descriptions, property DISPIDs,
// property page CLSIDs and IDispatch IIDs. You may use use
// IPerPropertyBrowsingImpl, IPersistPropertyBagImpl, IPersistStreamInitImpl,
// and ISpecifyPropertyPageImpl to utilize the information in you property
// map.
//
// NOTE: The BCB Wizard does *NOT* maintain your PROPERTY_MAP table. You must
//       add or remove entries manually.
//
BEGIN_PROPERTY_MAP(TClockLabelXImpl)
  // PROP_PAGE(CLSID_ClockLabelXPage)
END_PROPERTY_MAP()

// The DECLARE_ACTIVEXCONTROL_REGISTRY macro declares a static 'UpdateRegistry' 
// routine which registers the basic information about your control. The
// parameters expected by the macro are the ProgId & the ToolboxBitmap ID of
// your control.
//
DECLARE_ACTIVEXCONTROL_REGISTRY("ClockLabel.ClockLabelX", 1);

protected: 
  STDMETHOD(_set_Font(IFontDisp** Value));
  STDMETHOD(AboutBox());
  STDMETHOD(DrawTextBiDiModeFlagsReadingOnly(long* Value));
  STDMETHOD(get_Alignment(TxAlignment* Value));
  STDMETHOD(get_AutoSize(TOLEBOOL* Value));
  STDMETHOD(get_BorderStyle(TxStaticBorderStyle* Value));
  STDMETHOD(get_Caption(BSTR* Value));
  STDMETHOD(get_Color(::OLE_COLOR* Value));
  STDMETHOD(get_Cursor(short* Value));
  STDMETHOD(get_DoubleBuffered(TOLEBOOL* Value));
  STDMETHOD(get_DragCursor(short* Value));
  STDMETHOD(get_DragMode(TxDragMode* Value));
  STDMETHOD(get_Enabled(TOLEBOOL* Value));
  STDMETHOD(get_Font(IFontDisp** Value));
  STDMETHOD(get_ParentColor(TOLEBOOL* Value));
  STDMETHOD(get_ShowAccelChar(TOLEBOOL* Value));
  STDMETHOD(get_Visible(TOLEBOOL* Value));
  STDMETHOD(InitiateAction());
  STDMETHOD(IsRightToLeft(TOLEBOOL* Value));
  STDMETHOD(set_Alignment(TxAlignment Value));
  STDMETHOD(set_AutoSize(TOLEBOOL Value));
  STDMETHOD(set_BorderStyle(TxStaticBorderStyle Value));
  STDMETHOD(set_Caption(BSTR Value));
  STDMETHOD(set_Color(::OLE_COLOR Value));
  STDMETHOD(set_Cursor(short Value));
  STDMETHOD(set_DoubleBuffered(TOLEBOOL Value));
  STDMETHOD(set_DragCursor(short Value));
  STDMETHOD(set_DragMode(TxDragMode Value));
  STDMETHOD(set_Enabled(TOLEBOOL Value));
  STDMETHOD(set_Font(IFontDisp* Value));
  STDMETHOD(set_ParentColor(TOLEBOOL Value));
  STDMETHOD(set_ShowAccelChar(TOLEBOOL Value));
  STDMETHOD(set_Visible(TOLEBOOL Value));
  STDMETHOD(UseRightToLeftReading(TOLEBOOL* Value));
  STDMETHOD(UseRightToLeftScrollBar(TOLEBOOL* Value));
  STDMETHOD(get_Active(TOLEBOOL* Value));
  STDMETHOD(get_ShowDate(TOLEBOOL* Value));
  STDMETHOD(get_UpdateInterval(long* Value));
  STDMETHOD(set_Active(TOLEBOOL Value));
  STDMETHOD(set_ShowDate(TOLEBOOL Value));
  STDMETHOD(set_UpdateInterval(long Value));
private:
  TTimer*  FTimer;
  bool     FShowDate;
  void __fastcall OnTimer(TObject* Sender);
public:
  __fastcall TClockLabelXImpl();
  __fastcall ~TClockLabelXImpl();

  HRESULT IPersistStreamInit_Load(LPSTREAM pStm, ATL_PROPMAP_ENTRY* pMap);
  HRESULT IPersistStreamInit_Save(LPSTREAM pStm, BOOL fClearDirty,
    ATL_PROPMAP_ENTRY* pMap);

};
//---------------------------------------------------------------------------
#endif
